package PScm::Closure;

use strict;
use warnings;
use base qw(PScm);

sub new {
    my ($class, $args, $body, $env) = @_;

    bless {
        args => $args,
        body => $body,
        env  => $env,
    }, $class;
}

sub args { $_[0]->{args}->value }
sub body { $_[0]->{body} }
sub env  { $_[0]->{env} }

sub _apply {
    my ($self, $ra_args, $cont) = @_;

    my $extended_env =
      $self->env->ExtendUnevaluated([$self->args], $ra_args);
    $self->body->Eval($extended_env, $cont);
}

sub as_string {
    my ($self) = @_;
    return PScm::Expr::List->new(
        $self->_symbol,
        $self->{args},
        $self->{body}
    )->as_string;
}

################################
package PScm::Closure::Function;

use base qw(PScm::Closure);
use PScm::Continuation;

sub Apply {
    my ($self, $form, $env, $cont) = @_;

    $form->map_eval(
        $env,
        cont {
            my ($ra_evaluated_args) = @_;
            $self->_apply($ra_evaluated_args, $cont);
        }
    );
}

sub _symbol {
    PScm::Expr::Symbol->new('lambda');
}

1;
