package PScm::Continuation;

use strict;
use warnings;
use base qw(PScm);

require Exporter;

our @ISA = qw(PScm Exporter);

our @EXPORT = qw(cont);

sub new {
    my ($class, $cont) = @_;
    bless { cont => $cont }, $class;
}

sub cont(&) {
    my ($cont) = @_;
    return __PACKAGE__->new($cont);
}

sub Apply {
    my ($self, $form, $env, $cont) = @_;
    $form->map_eval(
        $env,
        cont {
            my ($ra_evaluated_args) = @_;
            $self->Cont($ra_evaluated_args->[0]);
        }
    );
}

sub Cont {
    my ($self, $arg) = @_;
    return cont { $self->{cont}->($arg) };
}

sub Bounce {
    my ($self) = @_;
    $self->{cont}->();
}

sub Eval {
    my ($self, $env, $cont) = @_;
    $cont->Cont($self);
}

1;
